;-------------------------------------------------------------------------------------------
;
; XpressNet/PC interface (mint Lenz LI100F)
;
; v0.9
;
;
; www.tfd.hu
; tfd@tfd.hu
;
;-------------------------------------------------------------------------------------------





	processor	16f73
	include		"p16f73.inc"
	__config	_BODEN_OFF & _CP_ALL & _PWRTE_OFF & _WDT_OFF & _HS_OSC
	radix		dec


;
; Lokmaus2 csak az 1,2,3,4,5,29,30 XpressNet cmeket tmogatja!
;




;------ konstansok


OSCFQ	equ	20000000	;oszcilltor frekvencia [Hz]




;------ portok



#define	UART2_CTS	PORTC,0
#define	UART2_RX	PORTC,1
#define	UART2_TX	PORTC,2
#define LED		PORTC,3

#define	XN_DE		PORTC,5


;------ RAM


	cblock	20h

	Cntr1
	Cntr2

	LED_Cntr

	UART2_TXReg
	UART2_TXState
	UART2_RXReg
	UART2_RXState
	UART2_Baud
	UART2_BaudCntr


	FROMPC_ToutCntr
	FROMPC_XorByte
	FROMPC_BytesLeft
	FROMPC_BufferPtr
	FROMPC_ToXN

	TOPC_WPtr
	TOPC_RPtr
	TOPC_FSRTemp
	TOPC_DataTemp

	XN_State
	XN_BytesLeft
	XN_BufferPtr
	XN_CallByte
	XN_Addr
	XN_XorByte

	endc




	cblock	40h

	FROMPC_Buffer:32
	XN_Buffer:20

	endc



	cblock	7ch

	IRQ_FSRTemp
	IRQ_STATUSTemp
	IRQ_WTemp

	endc



	cblock	0a0h

	TOPC_Buffer:32

	endc


;------ program



	org	0

	goto	RESET



;
; TMR0 megszakts
; ----------------
;

	org	4

	movwf	IRQ_WTemp		;W mentse

	swapf	STATUS,w		;STATUS mentse
	clrf	STATUS
	movwf	IRQ_STATUSTemp

;	movlw	202			;idzt alaprtk (19200 baud, oszts nlkl)
	movlw	137			;idzt alaprtk (9600 baud, oszts nlkl)
	movwf	TMR0

	bcf	INTCON,T0IF		;megszaktst vettk



;	decfsz	UART2_BaudCntr,f	;bitsebessg oszt cskken
;	goto	irqend

;	movf	UART2_Baud,w		;bitsebessg oszt alaprtk
;	movwf	UART2_BaudCntr


;
; Soft UART TX
; ------------
;
; Az utna kvetkez vtel miatt fontos,
; hogy mindg ugyanannyi id alatt fusson le.
;
; Ha UART2_TXState=40, akkor adsra ksz.
; UART2_TXReg be adatot berni, majd UART2_TXState trlsre
; elindul az ads.
;

	movf	UART2_TXState,w
	addwf	PCL,f

	goto	u2txstb			;0 - start bit ads
	goto	u2txnop			;1
	goto	u2txnop			;2
	goto	u2txnop			;3

	goto	u2txdb			;4 - 0. bit ads
	goto	u2txnop			;5
	goto	u2txnop			;6
	goto	u2txnop			;7

	goto	u2txdb			;8 - 1. bit ads
	goto	u2txnop			;9
	goto	u2txnop			;10
	goto	u2txnop			;11

	goto	u2txdb			;12 - 2. bit ads
	goto	u2txnop			;13
	goto	u2txnop			;14
	goto	u2txnop			;15

	goto	u2txdb			;16 - 3. bit ads
	goto	u2txnop			;17
	goto	u2txnop			;18
	goto	u2txnop			;19

	goto	u2txdb			;20 - 4. bit ads
	goto	u2txnop			;21
	goto	u2txnop			;22
	goto	u2txnop			;23

	goto	u2txdb			;24 - 5. bit ads
	goto	u2txnop			;25
	goto	u2txnop			;26
	goto	u2txnop			;27

	goto	u2txdb			;28 - 6. bit ads
	goto	u2txnop			;29
	goto	u2txnop			;30
	goto	u2txnop			;31

	goto	u2txdb			;32 - 7. bit ads
	goto	u2txnop			;33
	goto	u2txnop			;34
	goto	u2txnop			;35

	goto	u2txspb			;36 - stop bit ads
	goto	u2txnop			;37
	goto	u2txnop			;38
	goto	u2txnop			;39

	goto	u2txrdy			;40 - ads befejezve

u2txstb	nop
	nop
	nop
	nop
	bcf	UART2_TX
	goto	u2txend

u2txdb	rrf	UART2_TXReg,f		;bit kilptets
	btfsc	STATUS,C
	goto	u2tx1
	nop
	bcf	UART2_TX		;kilptetett bit 0
	goto	u2txend
u2tx1	bsf	UART2_TX		;kilptetett bit 1
	goto	u2txend

u2txspb	nop
	nop
	nop
	nop
	bsf	UART2_TX
	goto	u2txend

u2txnop	nop
	nop
	nop
	nop
	nop
	goto	u2txend

u2txrdy	nop
	nop
	nop
	nop
	nop
	nop
	decf	UART2_TXState,f		;maradunk ebben az llapotban

u2txend	incf	UART2_TXState,f		;kvetkez llapot



;
; Soft UART RX
; ------------
;
; Futs ideje nem fontos, nincs utna semmi rdekes...
;
; UART2_RXState trlse engedlyezi a vtelt.
; Ha UART2_TXState=40, akkor a vett adat az UART2_RXReg-ben.
;

	movf	UART2_RXState,w
	addwf	PCL,f

	goto	u2rxstb			;0 - start bitre vrs
	goto	u2rxnext		;1
	goto	u2rxnext		;2
	goto	u2rxnext		;3

	goto	u2rxnext		;4
	goto	u2rxnext		;5
	goto	u2rxdb			;6 - 0. bit vtel
	goto	u2rxnext		;7

	goto	u2rxnext		;8
	goto	u2rxnext		;9
	goto	u2rxdb			;10 - 1. bit vtel
	goto	u2rxnext		;11

	goto	u2rxnext		;12
	goto	u2rxnext		;13
	goto	u2rxdb			;14 - 2. bit vtel
	goto	u2rxnext		;15

	goto	u2rxnext		;16
	goto	u2rxnext		;17
	goto	u2rxdb			;18 - 3. bit vtel
	goto	u2rxnext		;19

	goto	u2rxnext		;20
	goto	u2rxnext		;21
	goto	u2rxdb			;22 - 4. bit vtel
	goto	u2rxnext		;23

	goto	u2rxnext		;24
	goto	u2rxnext		;25
	goto	u2rxdb			;26 - 5. bit vtel
	goto	u2rxnext		;27

	goto	u2rxnext		;28
	goto	u2rxnext		;29
	goto	u2rxdb			;30 - 6. bit vtel
	goto	u2rxnext		;31

	goto	u2rxnext		;32
	goto	u2rxnext		;33
	goto	u2rxdb			;34 - 7. bit vtel
	goto	u2rxnext		;35

	goto	u2rxnext		;36
	goto	u2rxnext		;37
	goto	u2rxnext		;38 - stop bitet lehetne vizsglni...
	goto	u2rxnext		;39

	goto	u2rxend			;40 - vtel befejezve


u2rxstb	btfss	UART2_RX		;ha a bemenet alacsony,
	goto	u2rxnext		;akkor kvetkez llapot, mert vtel elindult

	movf	FROMPC_ToutCntr,w	;vtel timeout szmll
	btfss	STATUS,Z		;ha mg nem 0,
	decf	FROMPC_ToutCntr,f	;akkor cskken

	goto	u2rxend			;llapot nem vltozik


u2rxdb	bcf	STATUS,C
	btfsc	UART2_RX		;adatbit
	bsf	STATUS,C
	rrf	UART2_RXReg,f		;belptets

u2rxnext
	incf	UART2_RXState,f		;kvetkez llapot

u2rxend


;
; PC fel men gyr kezelse
; ---------------------------
;
;
;
;	


	movf	TOPC_WPtr,w		;van mit adni?
	subwf	TOPC_RPtr,w
	btfsc	STATUS,Z
	goto	topcend			;nincs

	movf	UART2_TXState,w		;lehet adni?
	sublw	40
	btfss	STATUS,Z
	goto	topcend			;nem


	movf	FSR,w			;FSR mentse
	movwf	IRQ_FSRTemp

	movf	TOPC_RPtr,w		;tovbbtand byte cme
	movwf	FSR

	movf	INDF,w			;kldend byte
	movwf	UART2_TXReg		;az adregiszterbe
	clrf	UART2_TXState		;s ads mehet

	incf	TOPC_RPtr,w		;buffer olvass mutat nvekszik
	andlw	31
	addlw	TOPC_Buffer
	movwf	TOPC_RPtr


	movf	IRQ_FSRTemp,w		;FSR visszatlts
	movwf	FSR

topcend




	bsf	LED
	btfsc	LED_Cntr,7
	bcf	LED

	incfsz	LED_Cntr,w
	movwf	LED_Cntr




irqend	

	swapf	IRQ_STATUSTemp,w	;STATUS visszallts
	movwf	STATUS

	swapf	IRQ_WTemp,f		;W visszallts
	swapf	IRQ_WTemp,w

	retfie



;
; PC fel men gyr alaphelyzetbe lltsa
; -----------------------------------------
;
;



TOPC_Reset

	movlw	TOPC_Buffer		;a buffer elejn ll
	movwf	TOPC_WPtr		;az rs
	movwf	TOPC_RPtr		;s az olvass mutat is

	return


;
; 1 byte a PC fel men gyrbe
; -----------------------------
;
; W-ben a kldend byte
;



TOPC_PutCh

	movwf	TOPC_DataTemp		;kldend adat mentse

	movf	FSR,w			;FSR mentse
	movwf	TOPC_FSRTemp

	movf	TOPC_WPtr,w		;gyrbe berand byte cme
	movwf	FSR


	;olvasst nem rheti utol!!


	movf	TOPC_DataTemp,w		;adat
	movwf	INDF			;a gyrbe

	incf	TOPC_WPtr,w		;buffer rs mutat nvekszik
	andlw	31
	addlw	TOPC_Buffer
	movwf	TOPC_WPtr


	movf	TOPC_FSRTemp,w		;FSR visszatlts
	movwf	FSR

	return




;
; Fprogram - Inicializlsok
; ---------------------------
;


RESET	movlw	01000101b		;TX, XN_DE, LED, UART2_TX, UART2_CTS llapota
	movwf	PORTC			;majd kimenetre llts utn

	bsf	STATUS,RP0		;page 1

	movlw	10010010b		;TX, XN_DE, LED, UART2_TX, UART2_CTS kimenetek
	movwf	PORTC

	movlw	00001000b		;PORTB felhzs bekapcsolva,TMR0 bels rajellel 1:1
	movwf	OPTION_REG

	movlw	00000110b		;PORTA digitlis (s alapbl bemenet)
	movwf	ADCON1

	bcf	STATUS,RP0		;page 0


	rlf	PORTA,w			;XpressNet cm DIP-rl
	andlw	00011100b
	movwf	XN_Addr
	btfsc	XN_Addr,3
	bsf	XN_Addr,1
	btfsc	XN_Addr,4
	bsf	XN_Addr,0
	movf	XN_Addr,w
	andlw	7
	addlw	24
	movwf	XN_Addr

	movlw	2			;9600 baud
;	btfss	PORTA,4			;DIP?
;	movlw	1			;19200 baud
	movwf	UART2_Baud
	movwf	UART2_BaudCntr


	;DIP5 - PORTA,5 nem haszlt


	call	TOPC_Reset		;PC fel men gyr alapllapot

	call	FROMPC_Reset		;PC vtel alapllapot

	call	XN_ResetRX		;XpressNet vtelen indulunk


	call	DELAY



	;itt majd vrni kell egy kis vteli csendre!!!



	clrf	LED_Cntr

	movlw	40
	movwf	UART2_TXState		;soft UART TX alapllapot
	clrf	UART2_RXState		;soft UART RX alapllapot

	bsf	INTCON,T0IE		;TMR0 megszakts engedlyezs
	bsf	INTCON,T0IF		;megszakts azonnal, amint GIE=1
	bsf	INTCON,GIE		;megszakts most mr mehet


	bsf	STATUS,RP0

	movlw	01100100b		;9 bit, tx enable, BRGH=1
	movwf	TXSTA

	movlw	(OSCFQ/(16*62500))-1	;62500 baud
	movwf	SPBRG

	bcf	STATUS,RP0

	movlw	11010000b		;serial port enable, 9 bit, rx enable
	movwf	RCSTA





;
; PC fell jv adatok kezelse
; -----------------------------
;
;

LOOP	movf	FROMPC_BytesLeft,f		;ha a PC-tl jv csomagba mr nem
	btfsc	STATUS,Z			;kell tbb byte, akkor az adott csomag
	goto	pcend				;XpressNet tovbbtsra vr...

	;lehetne timeout, hogy meddig vrhat....
	;br ezt inkbb az xn oldalnak kne nzni, hogy jn-e slot...

	movlw	40				;a PC fell jtt adat?
	subwf	UART2_RXState,w
	btfsc	STATUS,Z
	goto	pcstore				;akkor troljuk

	incfsz	FROMPC_BytesLeft,w		;csomag folyamatban a PC fell?
	goto	pcpinp
	goto	pcend				;ha nincs, akkor vrunk...

pcpinp	movf	FROMPC_ToutCntr,w		;timeout?
	btfss	STATUS,Z
	goto	pcend				;nem

	movlw	1				;timeout hiba klds a PC-nek
	call	TOPC_PutCh
	movlw	1
	call	TOPC_PutCh
	movlw	0
	call	TOPC_PutCh

	call	FROMPC_Reset			;s vtelt jraindtjuk

	goto	pcend


pcstore	movf	FROMPC_BufferPtr,w		;bufferbe
	movwf	FSR
	movf	UART2_RXReg,w			;a bejv byte-ot
	movwf	INDF				;troljuk
	xorwf	FROMPC_XorByte,f		;s xor byte-ot is szmoljuk


	incf	FROMPC_BufferPtr,f		;buffer mutat nvekszik

	movlw	0ffh				;timeout szmll trlse
	movwf	FROMPC_ToutCntr

	clrf	UART2_RXState			;s vtel mehet tovbb

	incfsz	FROMPC_BytesLeft,w		;header byte?
	goto	nhfpc

	movf	INDF,w				;akkor abban van
	andlw	15
	addlw	2
	movwf	FROMPC_BytesLeft		;a csomag hossza!
	movwf	FROMPC_ToXN			;XpressNet bufferbe msolshoz is kell mg

nhfpc	decfsz	FROMPC_BytesLeft,f		;kell mg adat a csomaghoz?
	goto	pcend				;igen, vrjuk a tbbit...

	bsf	UART2_CTS			;CTS tilts, mert teljes csomag megrkezett


	;xor byte ellenrzs
	;(mg) nem tudom, mi van akkor, ha nem j....
	;elmletileg nem is fontos...



	movf	FROMPC_Buffer,w			;header=11110000? (version info req)
	sublw	11110000b
	btfss	STATUS,Z			;ha nem,
	goto	pcend				;akkor majd megy tovbb XpressNet fel

	movlw	002h				;verzi inf visszaklds
	call	TOPC_PutCh
	movlw	030h
	call	TOPC_PutCh
	movlw	001h
	call	TOPC_PutCh
	movlw	033h
	call	TOPC_PutCh

	call	FROMPC_Reset			;csomagot felfdolgoztuk

pcend




;
; Xpressnet
; ---------
;
;


	btfss	XN_State,7			;XpressNet ads/vtel?
	goto	xntx



;
; Xpressnet fell jv adatok kezelse
; ------------------------------------
;
;



	btfss	PIR1,TMR2IF			;automatikus vlasz idzt letelt?
	goto	naansw

	movlw	1				;akkor automatikus vlasz a PC-nek
	call	TOPC_PutCh
	movlw	4
	call	TOPC_PutCh
	movlw	5
	call	TOPC_PutCh

	bcf	T2CON,TMR2ON			;vlasz idzt tilts
	bcf	PIR1,TMR2IF


naansw	btfss	RCSTA,OERR			;overrun hiba?
	goto	xnnovr				;(aminek csak a lassssgunk lehet az oka...)

	bcf	RCSTA,CREN			;vtel tilts a hiba trlshez

	call	XN_ResetRX			;majd jra engedlyezs

	goto	xnend				;s vrunk jabb adatra...


xnnovr	btfss	PIR1,RCIF			;jtt adat?
	goto	xnend				;ha nem, akkor vrunk...


	btfsc	RCSTA,RX9D			;call byte jtt?
	goto	xncb

	incfsz	XN_BytesLeft,w			;call byte-ra vrunk?
	goto	xnpbyte

	movf	RCREG,w				;ha igen, akkor RCREG rts
	goto	xnend				;s vrunk tovbb...


xncb	movf	RCREG,w				;call byte
	movwf	XN_CallByte			;trols


	;parits ellenrzs


	andlw	31				;broadcast?
	btfsc	STATUS,Z
	goto	xncbok

	subwf	XN_Addr,w			;vagy a mi cmnk?
	btfss	STATUS,Z
	goto	xnend				;ha nem akkor vrunk...


	movf	XN_CallByte,w			;ack request?
	andlw	01100000b
	btfsc	STATUS,Z
	goto	xnackrq

	sublw	01000000b			;normal inquiry?
	btfsc	STATUS,Z
	goto	xninq

xncbok	movlw	0feh				;call byte megvan
	movwf	XN_BytesLeft
	goto	xnend				;vrjuk a csomag tbbi byte-jt...


xnackrq	movlw	020h				;ack
	movwf	XN_Buffer
	movlw	020h
	movwf	XN_Buffer+1

	movlw	1				;PC-nek is megy a hibazenet
	call	TOPC_PutCh
	movlw	3
	call	TOPC_PutCh
	movlw	2
	call	TOPC_PutCh

	call	XN_ResetTX			;ads indulhat

	goto	xntx


xninq	
	clrf	LED_Cntr

	movf	FROMPC_BytesLeft,f		;PC-fell van adat?
	btfsc	STATUS,Z			;ha nincs,
	goto	xnpc

	call	XN_ResetRX			;akkor vtel jra alapra
	goto	xnend				;s vrunk tovbb...


xnpc	movlw	FROMPC_Buffer			;PC-tl jtt adatok kezdete
	movwf	FSR

pctoxn	movf	INDF,w				;PC bufferbl egy byte
	bsf	FSR,5
	movwf	INDF				;az XpressNet bufferbe
	bcf	FSR,5

	incf	FSR,f				;kvetkez byte

	decfsz	FROMPC_ToXN,f
	goto	pctoxn


	call	FROMPC_Reset			;PC vtel jra engedlyezs

	call	XN_ResetTX			;XpressNet ads pedig indulhat

	goto	xntx


xnpbyte	movf	XN_BufferPtr,w			;bufferbe
	movwf	FSR
	movf	RCREG,w				;a bejv byte-ot
	movwf	INDF				;troljuk

	incf	XN_BufferPtr,f			;buffer mutat nvekszik

	movlw	0feh				;header byte?
	subwf	XN_BytesLeft,w
	btfss	STATUS,Z
	goto	nhxn

	movf	INDF,w				;akkor abban van
	andlw	15
	addlw	2
	movwf	XN_BytesLeft			;a csomag hossza!

nhxn	decfsz	XN_BytesLeft,f			;kell mg adat a csomaghoz?
	goto	xnend				;igen, vrjuk a tbbit...


	;xor byte ellenrzs


	movf	XN_Buffer,w			;byteok szma a csomagban
	andlw	15
	addlw	2
	movwf	XN_BytesLeft

	movlw	XN_Buffer			;csomag kezdete
	movwf	FSR

xntopc	movf	INDF,w				;egy byte a csomagbl
	call	TOPC_PutCh			;megy a PC-nek

	incf	FSR,f				;kvetkez byte cme

	decfsz	XN_BytesLeft,f			;egy byte tkldve
	goto	xntopc


	bcf	T2CON,TMR2ON			;vlasz idzt tilts
	bcf	PIR1,TMR2IF

	call	XN_ResetRX			;vtel jra alapra
	goto	xnend				;s vrunk tovbb...



;
; Xpressnet ads
; --------------
;
;


xntx	bsf	STATUS,RP0
	btfsc	TXSTA,TRMT			;res az UART ad regisztere?
	goto	xnlehtx
	bcf	STATUS,RP0
	goto	xnend				;ha nem, akkor vrunk

xnlehtx	bcf	STATUS,RP0

	movf	XN_BytesLeft,f			;van mg adni val byte?
	btfss	STATUS,Z
	goto	xnleftt

	clrf	TMR2				;automatikus vlasz idzt engedlyezs
	movlw	01111111b
	movwf	T2CON

	call	XN_ResetRX			;ha utols is elment, akkor visszavltunk vtelre
	goto	xnend

xnleftt movf	XN_BufferPtr,w			;bufferbl
	movwf	FSR
	movf	INDF,w				;egy byte
	movwf	TXREG				;adsa

	incf	XN_BufferPtr,f			;buffer mutat nvekszik

	decf 	XN_BytesLeft,f			;egy byte leadva

xnend	goto	LOOP




;
; PC vtel alaphelyzetbe llts
; ------------------------------
;
;
;



FROMPC_Reset

	movlw	0ffh
	movwf	FROMPC_BytesLeft		;PC-tl jv csomag hossza mg ismeretlen
	movlw	FROMPC_Buffer			;vteli buffer az elejn ll
	movwf	FROMPC_BufferPtr
	clrf	FROMPC_XorByte			;xor byte alaprtk

	bcf	UART2_CTS			;CTS engedlyezs

	return


;
; XpressNet ads alaphelyzetbe llts
; ------------------------------------
;
;
;



XN_ResetTX

	clrf	XN_State			;ads md

	bsf	XN_DE				;RS485 ads engedlyezs

	bcf	RCSTA,CREN			;uart vtel tilts (visszhang miatt!)

	movf	XN_Buffer,w			;kldend byteok szma
	andlw	15
	addlw	2

	goto	xnrcom				;a tbbi kzs...


;
; XpressNet vtel alaphelyzetbe llts
; -------------------------------------
;
;
;


XN_ResetRX

	movlw	128				;vtel md
	movwf	XN_State

	bcf	XN_DE				;RS485 ads tilts

	bsf	RCSTA,CREN			;uart vtel engedlyezs

	clrf	XN_XorByte			;xor byte alaprtk

	movlw	0ffh				;ismeretlen a venni kvnt
xnrcom	movwf	XN_BytesLeft			;byteok szma

	movlw	XN_Buffer			;buffer mutat az elejre
	movwf	XN_BufferPtr

	return





;------------------------------------------------------------
; trash
;


DELAY	clrf	Cntr1
	clrf	Cntr2

dly	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop

	decfsz	Cntr1,f
	goto	dly
	decfsz	Cntr2,f
	goto	dly

	return






	end	

